#ifndef __SPRINGCARD_S9_OLD_H__
#define __SPRINGCARD_S9_OLD_H__

#ifdef __cplusplus
extern  "C"
{
#endif

SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API ReaderOpen(void);
SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API ReaderClose(void);
SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API CardClose(void);
SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API CardOpen(void);

SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API S9ReadDataArea(BYTE *dest, WORD addr, BYTE len);
SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API S9ReadProtectionArea(BYTE *dest, WORD addr);
SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API S9ReadSecurityArea(BYTE *dest);

SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API S9WriteDataArea(BYTE *source, WORD addr, BYTE len);
SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API S9WriteProtectionArea(BYTE *source, WORD addr, BYTE len);
SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API S9UpdateSecurityArea(BYTE *source, WORD addr, BYTE len);

SPRINGCARD_S9_LIB BOOL SPRINGCARD_S9_API S9PresentCardSecretCode(BYTE code2, BYTE code1);

#ifdef __cplusplus
}
#endif

#endif