// S9_ExplorerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "S9_Explorer.h"
#include "S9_ExplorerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "products/springcard/s9/springcard_s9.h"

#include "bin2c.h"

/* Global variable */
SCARDCONTEXT hContext = NULL;
SCARDHANDLE hCard = NULL;
DWORD SCardProtocol;
TCHAR SCardReaders[250];


// CONSTANTS
#define TIMER_ID          99

#define EDIT_DATA_LEFT     0
#define EDIT_DATA_TOP     12
#define EDIT_DATA_WIDTH   12
#define EDIT_DATA_HEIGHT  22
#define EDIT_DATA_OFFSET  34

#define EDIT_ROW_WIDTH    20

#define MAX_EDIT_LABEL    16
#define MAX_EDIT_DATA     64
#define MAX_EDIT_ADDRESS   4
#define MAX_EDIT_ROW       4

#define MAX_DATA        1024
#define SECURITY_DATA      4
#define STATUS_DATA        2
char buffer_data[MAX_DATA*2];

#define IDC_EDIT_ADDRESS_FIRST  3072
#define IDC_EDIT_DATA_FIRST     IDC_EDIT_ADDRESS_FIRST + MAX_EDIT_ADDRESS
#define IDC_EDIT_LABEL_FIRST    IDC_EDIT_DATA_FIRST    + MAX_EDIT_DATA
#define IDC_EDIT_ROW_FIRST      IDC_EDIT_LABEL_FIRST   + MAX_EDIT_LABEL
#define IDC_EDIT_ASCII_FIRST    IDC_EDIT_ROW_FIRST	   + MAX_EDIT_ROW

#define EDIT_DATA_STYLE         ES_CENTER   | ES_MULTILINE  | WS_CHILD | WS_VISIBLE | WS_TABSTOP 
#define EDIT_LABEL_STYLE        ES_CENTER | ES_MULTILINE  | WS_CHILD | WS_VISIBLE
#define EDIT_ASCII_STYLE        ES_LEFT   | ES_MULTILINE  | WS_CHILD | WS_VISIBLE | WS_BORDER

int     command_id = 0;
BYTE    address_hi = 0,address_low = 0;
int     address    = 0;
unsigned short     EditCtrID_selected;

CEdit edit_data   [MAX_EDIT_DATA];
CEdit edit_address[MAX_EDIT_ADDRESS];
CEdit edit_label  [MAX_EDIT_LABEL];
CEdit edit_row    [MAX_EDIT_ROW];
CEdit edit_ascii[1];
/////////////////////////////////////////////////////////////////////////////
// CS9_ExplorerDlg dialog

CS9_ExplorerDlg::CS9_ExplorerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CS9_ExplorerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CS9_ExplorerDlg)
	m_status = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CS9_ExplorerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CS9_ExplorerDlg)
	DDX_Text(pDX, IDC_STATUS, m_status);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CS9_ExplorerDlg, CDialog)
	//{{AFX_MSG_MAP(CS9_ExplorerDlg)
	ON_BN_CLICKED(IDC_WRITE, OnWrite)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN1, OnDeltaposSpin1)
	ON_BN_CLICKED(IDC_ON, OnOn)
	ON_BN_CLICKED(IDC_OFF, OnOff)
	ON_BN_CLICKED(IDC_AUTHENTICATION, OnBtnWriteEc)
	ON_BN_CLICKED(IDC_READ, OnRead)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	//}}AFX_MSG_MAP
	ON_EN_SETFOCUS(IDC_EDIT_ADDRESS_FIRST, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_ADDRESS_FIRST + 1 , OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_ADDRESS_FIRST + 2 , OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_ADDRESS_FIRST + 3 , OnSetfocusEdit1)
	//
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST     , OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST +  1, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST +  2, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST +  3, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST +  4, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST +  5, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST +  6, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST +  7, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST +  8, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST +  9, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 10, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 11, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 12, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 13, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 14, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 15, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 16, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 17, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 18, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 19, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 20, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 21, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 22, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 23, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 24, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 25, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 26, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 27, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 28, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 29, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 30, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 31, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 32, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 33, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 34, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 35, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 36, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 37, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 38, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 39, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 40, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 41, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 42, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 43, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 44, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 45, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 46, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 47, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 48, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 49, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 50, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 51, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 52, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 53, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 54, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 55, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 56, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 57, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 58, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 59, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 60, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 61, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 62, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 63, OnSetfocusEdit1)
	ON_EN_SETFOCUS(IDC_EDIT_DATA_FIRST + 64, OnSetfocusEdit1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CS9_ExplorerDlg message handlers

BOOL CS9_ExplorerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	CreateGrid(MAX_EDIT_ROW);
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

/*-------------------------------------------------------------------*/
void CS9_ExplorerDlg::CreateGrid(int line)
{
	unsigned char value;
	char label[2];
	char data[2] = { 0x30,0x00};
	char row[5];
	int i ,j,edit_idx,left, top, rigth, bottom, delta =0 , ctrl_id;

	left   = EDIT_DATA_LEFT;
	top    = EDIT_DATA_TOP ;
	rigth  = EDIT_DATA_LEFT + EDIT_DATA_WIDTH;
	bottom = top + EDIT_DATA_HEIGHT;

	// Edit Address create//
	for (i=0 ; i < MAX_EDIT_ADDRESS ; i++)
	{
		ctrl_id = IDC_EDIT_ADDRESS_FIRST + i;
		CreateEdit(edit_address , i, ctrl_id , left + delta ,top ,rigth + delta,bottom , EDIT_LABEL_STYLE /*EDIT_DATA_STYLE*/ , data);
		delta = delta + EDIT_DATA_WIDTH;
	}

	left  += EDIT_DATA_OFFSET;
	rigth += EDIT_DATA_OFFSET;
	top    = top  + EDIT_DATA_HEIGHT +10 ;
	bottom = top + EDIT_DATA_HEIGHT -5;
	delta =  EDIT_DATA_WIDTH -2;
	value = (MAX_EDIT_DATA/2)/line;

  // Edit Label create//
	for (i=0 ; i < value ; i++)
	{			
		edit_idx = i;
		ctrl_id = IDC_EDIT_LABEL_FIRST + edit_idx ;	
		label[0] = bin2hex(address + i);
		label[1] = 0x00;
		CreateEdit(edit_label , edit_idx , ctrl_id , left + delta ,top ,rigth + delta,bottom , EDIT_LABEL_STYLE , label);
		delta = delta + 2*EDIT_DATA_WIDTH +2 ;
	}
	left   = EDIT_DATA_LEFT;
	rigth  = EDIT_DATA_LEFT + EDIT_DATA_WIDTH;
    top    = top  + EDIT_DATA_HEIGHT -5 ;
	bottom = top + EDIT_DATA_HEIGHT;
	delta =  0;

	// Edit Data create//
	for (j=0 ; j < line ; j++)
	{
		// Edit Row create //
		edit_idx = j;
		ctrl_id = IDC_EDIT_ROW_FIRST + edit_idx ;
		bin2c(value * j, row, 4);
		row[4] = 0x00;
		CreateEdit(edit_row , edit_idx , ctrl_id , left ,top ,rigth + EDIT_ROW_WIDTH,bottom  , EDIT_LABEL_STYLE , row);
		left  += EDIT_DATA_OFFSET;
		rigth += EDIT_DATA_OFFSET;
		/*--------------------------------------*/
		for (i=0 ; i < value ; i++)
		{
			/*** Create Edit Control - High **/
			edit_idx = (i*2)+(j*value*2);
			ctrl_id = IDC_EDIT_DATA_FIRST + edit_idx ;	
			CreateEdit(edit_data , edit_idx , ctrl_id , left + delta ,top ,rigth + delta,bottom , EDIT_DATA_STYLE , "0");
			//
			/*** Create Edit Control - Low ***/
			edit_idx = ((i*2)+1)+(j*value*2);
			delta += EDIT_DATA_WIDTH ;
			ctrl_id = IDC_EDIT_DATA_FIRST + edit_idx;
			CreateEdit(edit_data, edit_idx, ctrl_id, left + delta ,top , rigth + delta, bottom , EDIT_DATA_STYLE , "0");
			delta = delta + EDIT_DATA_WIDTH +2;
		}
		delta =0;
		left   = EDIT_DATA_LEFT;
		top    += EDIT_DATA_HEIGHT +4;
		rigth  = EDIT_DATA_LEFT + EDIT_DATA_WIDTH;
		bottom = top + EDIT_DATA_HEIGHT;
	}
	left  += EDIT_DATA_OFFSET ;
	rigth += EDIT_DATA_OFFSET + (EDIT_DATA_WIDTH * MAX_EDIT_LABEL)+ 2 /*(MAX_EDIT_LABEL/2)*2*/;
	CreateEdit(edit_ascii, 0, IDC_EDIT_ASCII_FIRST, left + delta ,top , rigth , bottom , EDIT_ASCII_STYLE , "");
}

/*-------------------------------------------------------------------*/
void CS9_ExplorerDlg::OnSetfocusEdit1() 
{
	// TODO: Add your control notification handler code here
	unsigned short i;
	CEdit *ptr_Edit;

    

	// Edit Selected 
	ptr_Edit = (CEdit *)GetFocus();
	
	// Deselected the older one
    if (EditCtrID_selected != ptr_Edit->GetDlgCtrlID())
	{ 
		// Edit Data ?
		if ( (EditCtrID_selected>= IDC_EDIT_DATA_FIRST) && (EditCtrID_selected < IDC_EDIT_LABEL_FIRST) )
		{   
			// I don't why I have to use a variable ???
            i = EditCtrID_selected;
			i -= IDC_EDIT_DATA_FIRST;
			edit_data[i].SetReadOnly(TRUE);
		}
		// Edit Address ?
		if ( (EditCtrID_selected>= IDC_EDIT_ADDRESS_FIRST) && (EditCtrID_selected < IDC_EDIT_DATA_FIRST) )
		{
			i = EditCtrID_selected - IDC_EDIT_ADDRESS_FIRST;
			edit_address[i].SetReadOnly(TRUE);
		}
    }
	if ( 
		( (ptr_Edit->GetDlgCtrlID()>= IDC_EDIT_DATA_FIRST) && (ptr_Edit->GetDlgCtrlID() < IDC_EDIT_LABEL_FIRST) )
		||
		( (ptr_Edit->GetDlgCtrlID()>= IDC_EDIT_ADDRESS_FIRST) && (ptr_Edit->GetDlgCtrlID() < IDC_EDIT_DATA_FIRST) )
		)
	{
		ptr_Edit->SetReadOnly(FALSE);
		ptr_Edit->SetSel(0,-1,FALSE);
		EditCtrID_selected =  ptr_Edit->GetDlgCtrlID();
	}
}
/*-------------------------------------------------------*/
/* CreateEdit                                            */
/*-------------------------------------------------------*/
void CS9_ExplorerDlg::CreateEdit( CEdit *ptr_Edit, int id_idx,int id_ctrl,int left_param, int top_param ,int rigth_param ,int bottom_param, DWORD style,const char* init_text)
{
	CEdit *ptr;
	CString text;

	text = CString(init_text);

	ptr = ptr_Edit + id_idx;
	ptr->Create(style, CRect(left_param ,top_param ,rigth_param,bottom_param), this, id_ctrl);		
   
	ptr->SetReadOnly(TRUE);
			// Init to zero
	SetDlgItemText(id_ctrl ,text);
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::OnDeltaposSpin1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	CString bstrText;

	// TODO: Add your control notification handler code here
	
	// Down
	if (pNMUpDown->iDelta == 1)
	{
		EditDown();
		
	}
	else
	// Up
	{
        EditUp();
	
	}
	*pResult = 0;
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::Increment(CString *cstring_value)
{
	unsigned char value;
	char string_value;

	string_value = (char)*cstring_value[0];
	value = c2bin(&string_value, 1);	
	if (value >=15)
		value = 0;
	else
		value = value +1 ;
	string_value = bin2hex(value);
	*cstring_value = string_value;
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::Decrement(CString *cstring_value)
{
	unsigned char value;
	char string_value;

	string_value = (char)*cstring_value[0];
	value = c2bin(&string_value, 1);	
	if (value <= 0)
		value = 15;
	else
		value = value -1;
	string_value = bin2hex(value);
	*cstring_value = string_value;
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::DecrementEditSelected(CEdit *ptr , int max_edit, int first_id)
{
	CString value_text;
	int i;

	for (i=0 ; i< max_edit; i++)
	{
		if ( (ptr+i)->m_hWnd != 0)
		{
 			if ( ((ptr+i)->GetStyle() & ES_READONLY) != ES_READONLY)
			{
				GetDlgItemText( first_id +i, value_text);
				Decrement(&value_text);
 				SetDlgItemText( first_id +i ,value_text);
			}
		}
	}
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::IncrementEditSelected(CEdit *ptr , int max_edit, int first_id)
{
	CString value_text;
	int i;

	for (i=0 ; i< max_edit; i++)
	{
		if ( (ptr+i)->m_hWnd != 0)
		{
 			if ( ((ptr+i)->GetStyle() & ES_READONLY) != ES_READONLY)
			{
				GetDlgItemText( first_id +i, value_text);
				Increment(&value_text);
 				SetDlgItemText( first_id +i ,value_text);
			}
		}
	}
}

//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::SetEditData(char *data , int max_data , int max_buffer)
{
	int i;
	char low[2];
	char hi[2];
	CString value;
	char * ptr_data;
	ptr_data = buffer_data;

	low[1] = 0x00;
	hi[1]  = 0x00;

	for (i=0; i< max_data; i++)
	{
		memcpy(hi,(data + i),1);
		memcpy(low,(data + i),1);

		hi[0] = (hi[0] >> 4) & 0x0F;
		low[0] = low[0] & 0x0F;

		hi[0]  =  bin2hex((int) hi[0]);
		low[0] =  bin2hex((int) low[0]);

		value = hi;
		SetDlgItemText( IDC_EDIT_DATA_FIRST + (i*2) ,value);
		value = low;
		SetDlgItemText( IDC_EDIT_DATA_FIRST + (i*2) +1 ,value);
	}

	for (i=0; i< max_buffer; i++)
	{
		memcpy(hi,(data + i),1);
		hi[0] = (hi[0] >> 4) & 0x0F;
	    memcpy(low,(data+i),1);
		low[0] = low[0] & 0x0F;
		hi[0]  =  bin2hex((int) hi[0]);
		low[0] =  bin2hex((int) low[0]);

		memcpy(ptr_data ,hi,1);
		ptr_data ++;

		memcpy(ptr_data,low,1);
		ptr_data ++;
	}
}

//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::UpdateAddress()
{
	int i;
	char row[5];
	char col[2];
	CString value;
	BYTE data[MAX_EDIT_DATA/2];

	GetAddress();
	// Update Row
	for (i=0 ; i < MAX_EDIT_ROW ; i++)
	{
		bin2c(address + (i * 8), row, 4);
		row[4] = 0x00;
		value = row;
		SetDlgItemText( IDC_EDIT_ROW_FIRST + i ,value);
	}
	// Update Col
	for (i=0 ; i < MAX_EDIT_LABEL ; i++)
	{
		bin2c((address_low & 0x0f) + i, col, 1);
		col[1] = 0x00;
		value = col;
		SetDlgItemText( IDC_EDIT_LABEL_FIRST + i ,value);
	}
    GetEditData((char *)data , MAX_EDIT_DATA/2);
	SetDlgItemText( IDC_EDIT_ASCII_FIRST  ,CString((char *)data));
	UpdateData(FALSE);
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::GetAddress()
{
	unsigned short value_text[2];

    //Which Adress ?
	// Low
	GetDlgItemText( IDC_EDIT_ADDRESS_FIRST, value_text, 2 ); 
	address_hi = c2bin((char *)value_text, 1) *16;
	GetDlgItemText( IDC_EDIT_ADDRESS_FIRST +1, value_text, 2 ); 
	address_hi += c2bin((char *)value_text, 1);
	// Low
	GetDlgItemText( IDC_EDIT_ADDRESS_FIRST +2, value_text, 2 ); 
	address_low = c2bin((char *)value_text, 1) *16;
	GetDlgItemText( IDC_EDIT_ADDRESS_FIRST +3, value_text, 2 ); 
	address_low += c2bin((char *)value_text, 1);

	address = address_hi * 256 + address_low;
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::GetEditData(char *ptr_data , int max_data)
{
	int i;
	BYTE data;
	unsigned short low[2];
	unsigned short hi[2];

	for (i=0; i< max_data; i++)
	{

		GetDlgItemText( IDC_EDIT_DATA_FIRST + (i*2), hi, 2 ); 
		data = c2bin((char *)hi, 1) *16;
		GetDlgItemText( IDC_EDIT_DATA_FIRST + (i*2)+1, low, 2 );
		data += c2bin((char *)low, 1);
		*(ptr_data + i) = data;
	}
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::EditDown()
{
	CEdit *ptr_edit;

// Edit Address selected//
	ptr_edit = edit_address;
	DecrementEditSelected(ptr_edit,MAX_EDIT_ADDRESS,IDC_EDIT_ADDRESS_FIRST);

	// Edit Data selected //
	ptr_edit = edit_data;
	DecrementEditSelected(ptr_edit,MAX_EDIT_DATA,IDC_EDIT_DATA_FIRST);
	UpdateAddress();
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::EditUp()
{
	CEdit *ptr_edit;

	// Edit Address selected//
	ptr_edit = edit_address;
	IncrementEditSelected(ptr_edit,MAX_EDIT_ADDRESS,IDC_EDIT_ADDRESS_FIRST);
	

	// Edit Data selected //
	ptr_edit = edit_data;
	IncrementEditSelected(ptr_edit,MAX_EDIT_DATA,IDC_EDIT_DATA_FIRST);
    UpdateAddress();
}
/*--------------------------------------------------------*/
void CS9_ExplorerDlg::OnRead() 
{
	LONG SCardLastError;
 	BYTE data[(MAX_EDIT_DATA/2)+2];
    BYTE buffer[SECURITY_DATA];
	BYTE status[STATUS_DATA];
	char text[3];
 
 	GetAddress();
 
 	CWaitCursor wait;
 	wait.Restore();
 
    /* Read Main memory */
	SCardLastError = SCardS9ReadDataArea(hCard, data, address, MAX_EDIT_DATA/2, status);
	if (SCardLastError != SCARD_S_SUCCESS)
    {
		m_status = "Read : Failed";
		goto failed;
	}

	SetEditData((char *) data , MAX_EDIT_DATA/2 , MAX_EDIT_DATA/2);
 	SetDlgItemText( IDC_EDIT_ASCII_FIRST  ,CString((char *)data));
	
	/* Read Security memory */
	SCardLastError = SCardS9ReadSecurityArea(hCard, buffer, status);
	if (SCardLastError != SCARD_S_SUCCESS)
    {
		m_status = "ReadSecurity : Failed";
		goto failed;
	}

	if (buffer[0] == 0)
	{
		m_status = "Security Code : Blocked";
	    bin2c(buffer[0], text, 2);
		text[2]='\0';
	    SetDlgItemText(IDC_COUNTER ,CString(text));
	} else
	{
		m_status = "Security Code : Not Blocked";
	    bin2c(buffer[0], text, 2);
		text[2]='\0';
	    SetDlgItemText(IDC_COUNTER ,CString(text));
	}

	UpdateData(FALSE);
	return;

failed:
	m_status += "(";
	m_status += SCardErrorToString(hContext,SCardLastError);
	m_status += ")";

 	UpdateData(FALSE);
 }
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::OnWrite() 
{
	LONG SCardLastError;
 	BYTE data[(MAX_EDIT_DATA/2)+2];
	BYTE status[STATUS_DATA];
 
 	GetAddress();
 
 	CWaitCursor wait;
 	wait.Restore();

	GetEditData((char *)data , MAX_EDIT_DATA/2);

	/* Write Main memory */
	SCardLastError = SCardS9WriteDataArea(hCard, data, address, MAX_EDIT_DATA/2, status);
	if (SCardLastError != SCARD_S_SUCCESS)
    {
		m_status  = "Write : Failed";
		goto failed;
	}

	m_status = "Write : Ok";
	UpdateData(FALSE);
	return;

failed:
	m_status += "(";
	m_status += SCardErrorToString(hContext,SCardLastError);
	m_status += ")";

 	UpdateData(FALSE);
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::OnBtnWriteEc() 
{
	LONG SCardLastError;
    BYTE buffer[SECURITY_DATA];
	BYTE status[STATUS_DATA];
 
 	CWaitCursor wait;
 	wait.Restore();
	
	/* Read Security memory */
	SCardLastError = SCardS9ReadSecurityArea(hCard, buffer, status);
	if (SCardLastError != SCARD_S_SUCCESS)
    {
		m_status = "ReadSecurity : Failed";
		goto failed;
	}

	if (buffer[0] == 0)
		m_status = "Security Code : Blocked";
	else
	{
		/* Not blocked then we try */
		SCardLastError = SCardS9PSCVerification(hCard, 0xFF, 0xFF, status);
		if (SCardLastError != SCARD_S_SUCCESS)
		{
			m_status = "PSCVerification : Failed";
			goto failed;
		}


		/* Read Security memory */
		SCardLastError = SCardS9ReadSecurityArea(hCard, buffer, status);
		if (SCardLastError != SCARD_S_SUCCESS)
		{
			m_status = "ReadSecurity : Failed";
			goto failed;
		}

		if (buffer[0] == 0xFF)
			m_status = "Security Code : Good";
		else
			m_status = "Security Code : Wrong";
	}

	UpdateData(FALSE);
	return;

failed:
	m_status += "(";
	m_status += SCardErrorToString(hContext,SCardLastError);
	m_status += ")";

 	UpdateData(FALSE);
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::OnConnect() 
{
	LONG SCardLastError;
 
 	CWaitCursor wait;
 	wait.Restore();

	/* Connect to the card */
	SCardLastError = SCardConnect(hContext,
                                SCardMultiStringItem(hContext, SCardReaders, 0),
                                SCARD_SHARE_DIRECT,
                                SCARD_PROTOCOL_RAW | SCARD_PROTOCOL_S9,
                                &hCard,
                                &SCardProtocol);
	if (SCardLastError != SCARD_S_SUCCESS)
		goto failed;


	/* Enable button */
    GetDlgItem(IDC_DISCONNECT)->EnableWindow(TRUE);
	GetDlgItem(IDC_READ)->EnableWindow(TRUE);
	GetDlgItem(IDC_WRITE)->EnableWindow(TRUE);
	GetDlgItem(IDC_AUTHENTICATION)->EnableWindow(TRUE);
	/* Disable button */
	GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
	
	m_status = "Card : Connected";
	UpdateData(FALSE);
	return;

failed:
	/* Try to eject the card */
    SCardDisconnect(hCard, SCARD_UNPOWER_CARD);

	m_status = "Card Connect : Failed(";
	m_status += SCardErrorToString(hContext,SCardLastError);
	m_status += ")";

 	UpdateData(FALSE);
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::OnDisconnect() 
{
	CWaitCursor wait;
 	wait.Restore();

	/* Try to eject the card */
    SCardDisconnect(hCard, SCARD_UNPOWER_CARD);

	/* Enable button */
    GetDlgItem(IDC_CONNECT)->EnableWindow(TRUE);
	/* Disable button */
	GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
	GetDlgItem(IDC_READ)->EnableWindow(FALSE);
	GetDlgItem(IDC_WRITE)->EnableWindow(FALSE);
	GetDlgItem(IDC_AUTHENTICATION)->EnableWindow(FALSE);

	m_status = "Card : Disconnected";
 	UpdateData(FALSE);
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::OnOn() 
{
	LONG SCardLastError;
	DWORD list_len;

	CWaitCursor wait;
	wait.Restore();

	/* Init PC/SC layer */
    SCardLastError = SCardEstablishContext(SCARD_SCOPE_SYSTEM, NULL, NULL, &hContext);
    if (SCardLastError != SCARD_S_SUCCESS)
      goto failed;

    /* Get readers list */
    list_len = sizeof(SCardReaders);
    SCardLastError = SCardListReaders(hContext, NULL, SCardReaders, &list_len);
    if (SCardLastError != SCARD_S_SUCCESS)
      goto failed;

	/* Enable button */
    GetDlgItem(IDC_OFF)->EnableWindow(TRUE);
	GetDlgItem(IDC_CONNECT)->EnableWindow(TRUE);
	/* Disable button */
	GetDlgItem(IDC_ON)->EnableWindow(FALSE);

    m_status = "Reader : Ready";
    UpdateData(FALSE);
	return;

failed:

	/* Free PC/SC layer */
    SCardReleaseContext(hContext);

	m_status = "Reader : Failed (";
	m_status += SCardErrorToString(hContext,SCardLastError);
	m_status += ")";
	UpdateData(FALSE);
}
//---------------------------------------------------------------------------------
void CS9_ExplorerDlg::OnOff() 
{
	CWaitCursor wait;
	wait.Restore();
  
    /* Free PC/SC layer */
    SCardReleaseContext(hContext);

	/* Enable button */
    GetDlgItem(IDC_ON)->EnableWindow(TRUE);
	/* Disable button */
	GetDlgItem(IDC_OFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
	GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
	GetDlgItem(IDC_READ)->EnableWindow(FALSE);
	GetDlgItem(IDC_WRITE)->EnableWindow(FALSE);
	GetDlgItem(IDC_AUTHENTICATION)->EnableWindow(FALSE);
	
	m_status = "Reader : Off";
	UpdateData(FALSE);
}

