/*****************************************************************************
*                     Copyright (c)  Gemplus Developpement 1992 - 1997
*
* Name        : BIN2C.H
*
* Description : 
*
  Author      : JL-GIRAUD
  Compiler    : All
  Host        : All

* $Id: bin2c.h,v 1.2 2000/09/04 08:19:06 rousseau Exp $
* $Log: bin2c.h,v $
* Revision 1.2  2000/09/04 08:19:06  rousseau
* code cleanup, changed the API and name for [Init|Close]Serial
*
*
******************************************************************************
*
* Warning     : 
* Remarks     : 
*
*****************************************************************************/

#include "springcard_i.h"

/* Transformsint value in a length char array   */
void    bin2c(int value,
              char *buffer,
              int length);
char    bin2hex(int v);

#ifndef INLINE_BIN2C
#define INLINE_BIN2C
SCARD_INLINE void bin2c2(int value,
                         char *buffer)
{
unsigned char nibble;

nibble = ((unsigned char) value >> 4) & 0x0F;
if (nibble >= 10)
buffer[0] = nibble + ('A' - 10);
else
buffer[0] = nibble + '0';
nibble = (unsigned char) value & 0x0F;
if (nibble >= 10)
buffer[1] = nibble + ('A' - 10);
else
buffer[1] = nibble + '0';
}
#endif
