#ifndef __SPRINGCARD_S10_OLD_H__
#define __SPRINGCARD_S10_OLD_H__

#ifdef __cplusplus
extern  "C"
{
#endif

SPRINGCARD_S10_LIB BOOL SPRINGCARD_S10_API ReaderOpen(void);
SPRINGCARD_S10_LIB BOOL SPRINGCARD_S10_API ReaderClose(void);
SPRINGCARD_S10_LIB BOOL SPRINGCARD_S10_API CardClose(void);
SPRINGCARD_S10_LIB BOOL SPRINGCARD_S10_API CardOpen(void);


SPRINGCARD_S10_LIB BOOL SPRINGCARD_S10_API S10ReadDataArea(BYTE *dest ,BYTE addr, BYTE len);
SPRINGCARD_S10_LIB BOOL SPRINGCARD_S10_API S10ReadProtectionArea(BYTE *dest);
SPRINGCARD_S10_LIB BOOL SPRINGCARD_S10_API S10ReadSecurityArea(BYTE *dest);

SPRINGCARD_S10_LIB BOOL SPRINGCARD_S10_API S10WriteDataArea(BYTE *source, BYTE addr, BYTE len);

SPRINGCARD_S10_LIB BOOL SPRINGCARD_S10_API S10UpdateSecurityArea(BYTE *source, BYTE addr, BYTE len);
SPRINGCARD_S10_LIB BOOL SPRINGCARD_S10_API S10PresentCardSecretCode(BYTE code3 , BYTE code2, BYTE code1);

#ifdef __cplusplus
}
#endif

#endif